Package org.xnio.channels

# Interface SuspendableChannel

All Superinterfaces:
  `AutoCloseable`, `Channel`, `Closeable`, `CloseableChannel`, `Configurable`, `InterruptibleChannel`, `SuspendableReadChannel`, `SuspendableWriteChannel`

All Known Subinterfaces:
  `BoundMultipointMessageChannel`, `ConnectedMessageChannel`, `ConnectedSslStreamChannel`, `ConnectedStreamChannel`, `MessageChannel`, `MulticastMessageChannel`, `MultipointMessageChannel`, `StreamChannel`

All Known Implementing Classes:
  `AssembledConnectedMessageChannel`, `AssembledConnectedSslStreamChannel`, `AssembledConnectedStreamChannel`, `AssembledMessageChannel`, `AssembledStreamChannel`, `FramedMessageChannel`, `TranslatingSuspendableChannel`

public interface SuspendableChannel extends CloseableChannel, SuspendableReadChannel, SuspendableWriteChannel
A suspendable bidirectional channel.

## Field Summary

### Fields inherited from interface org.xnio.channels.Configurable

`EMPTY`

## Method Summary

Modifier and Type
Method
Description
`ChannelListener.Setter<? extends SuspendableChannel>`
`getCloseSetter()`
Get the setter which can be used to change the close listener for this channel.
`ChannelListener.Setter<? extends SuspendableChannel>`
`getReadSetter()`
Get the setter which can be used to change the read listener for this channel.
`ChannelListener.Setter<? extends SuspendableChannel>`
`getWriteSetter()`
Get the setter which can be used to change the write listener for this channel.

### Methods inherited from interface org.xnio.channels.CloseableChannel

`getIoThread, getWorker`

### Methods inherited from interface org.xnio.channels.Configurable

`getOption, setOption, supportsOption`

### Methods inherited from interface org.xnio.channels.SuspendableReadChannel

`awaitReadable, awaitReadable, getReadThread, isReadResumed, resumeReads, shutdownReads, suspendReads, wakeupReads`

### Methods inherited from interface org.xnio.channels.SuspendableWriteChannel

`awaitWritable, awaitWritable, close, flush, getWriteThread, isOpen, isWriteResumed, resumeWrites, shutdownWrites, suspendWrites, wakeupWrites`

## Method Details

### getCloseSetter

ChannelListener.Setter<? extends SuspendableChannel> getCloseSetter()
Get the setter which can be used to change the close listener for this channel. If the channel is already closed, then the listener will not be called.

Specified by:
  `getCloseSetter` in interface `CloseableChannel`
Specified by:
  `getCloseSetter` in interface `SuspendableReadChannel`
Specified by:
  `getCloseSetter` in interface `SuspendableWriteChannel`
Returns:
  the setter

### getReadSetter

ChannelListener.Setter<? extends SuspendableChannel> getReadSetter()
Get the setter which can be used to change the read listener for this channel.

Specified by:
  `getReadSetter` in interface `SuspendableReadChannel`
Returns:
  the setter

### getWriteSetter

ChannelListener.Setter<? extends SuspendableChannel> getWriteSetter()
Get the setter which can be used to change the write listener for this channel.

Specified by:
  `getWriteSetter` in interface `SuspendableWriteChannel`
Returns:
  the setter